function [ P, T, B ] = kellerTriangulation( a,b,h_a,h_b  )

% Generation of an equidistant grid of a rectangle with the corners (0,0) and (a,b)
[x,y] = meshgrid (0:h_a:a, 0:h_b:b);

% Number of knots calculation in x- and y- direction
numNodesX= size(x,1);
numNodesY= size(x,2);

numNodes = numNodesX * numNodesY;

% Calculation of the edges knots indexes
B = [1:numNodesX, 2*numNodesX:numNodesX:numNodes-2*numNodesX, 1+numNodesX:numNodesX:numNodes-numNodesX  ,  numNodes:-1:numNodes-numNodesX];
B = sort(B);

% Triangle matrix generation 2* because of the orientation
i = 1:numNodes-numNodesX;
j = numNodesX:numNodesX:numNodes-numNodesX;
i = setdiff(i,j);
T1 = [i',i'+1,i'+numNodesX];

i = numNodesX+2:numNodes;
j = numNodesX+1:numNodesX:numNodes;
i = setdiff(i,j);
T2 =[ i', i'-1,i'-numNodesX] ;

T = [T1; T2 ];

% Meshgrid output from Matrix to vector
x = reshape(x,[],1); 
y = reshape(y,[],1);

% Assemble the Matrix in point P
P = [x';y'];
B = B';
