[ P, T, B ] = kellerTriangulation(7,4,0.1,0.1);

mytol = 100*eps;
DoF    = length(P);
vareps = 2*10^-5*ones(1,DoF);
index  = (P(1,:)<=3.2) & (P(1,:)>=3) & (P(2,:)<=4) & (P(2,:)>=1.5);
vareps(index) = 8.75*10^-7;

A = assembDiffusion (vareps, T, P);

f = zeros(1,DoF);
b = assembRightSide(T, P, f);

index    = find((P(1,:)<=0.5) & (P(1,:)>=0) & (P(2,:)<=4) & (P(2,:)>=3));

for i=index
  A(i,find(A(i,:))) = 0;
  A(i,i) = 1;
  b(i) = 323.15;
end  

BDirichletIndex = (P(1,B)<=7+mytol) & (P(1,B)>=7-mytol) & (P(2,B)<=1.2) & (P(2,B)>=0.2);
BDirichlet = B(BDirichletIndex); 
for i=BDirichlet'
  A(i,find(A(i,:))) = 0;
  A(i,i) = 1;
  b(i) = 283.15;
end  

u = A\b;
colormap gray
trisurf(T,P(1,:),P(2,:),u,'EdgeColor','none')
xlabel('x');ylabel('y');zlabel('Kelvin');