function [ A, b ] = applyDirichletBoundaryConditions(A,b, mesh, pGroup, f)

accessRow = mesh.BoundaryEdges(mesh.GBoundaryEdges == pGroup); %*\label{applDBC1}
firstNode  = mesh.edges(accessRow ,1);%*\label{applDBC2}
secondNode = mesh.edges(accessRow ,2);
allNodes = vertcat(firstNode, secondNode);
accessRow = unique(allNodes);

if isa(f,'function_handle')
  for i=accessRow'
    A(i,find(A(i,:))) = 0;
    A(i,i) = 1;
    x = mesh.P(1,i);
    y = mesh.P(2,i);
    b(i) = f(x,y);
  end
else
  for i=accessRow'
    A(i,find(A(i,:))) = 0;
    A(i,i) = 1;
    b(i) = f(i);
  end
end