function [ D ] = assemDiffusion1D( nodes, epsilon)
  nodes = nodes(:)'; DoF = length(nodes);
  h = nodes(2:length(nodes)) - nodes(1:length(nodes)-1);
  s = length(epsilon); 
  if s == 1 %*\label{assemDiffusion-1}
    epsilon = epsilon*ones(size(h));
  elseif s == length(nodes)
    epsilon =(epsilon(2:s) + epsilon(1:s-1))./2;
  end %*\label{assemDiffusion-2}

  if length(epsilon) ~= length(h)
    msg = 'Dimension of nodes and epsilon do not agree.';
    error(msg)
  end

  index1 = 2:DoF;   index2 = 1:DoF-1;   index3 = 1:DoF; %*\label{assemDiffusion-3}

  diagonal2 = -1*epsilon./h;  %*\label{assemDiffusion-4}

  diagonal(2:DoF-1) = epsilon(1:DoF-2)./h(1:DoF-2);
  diagonal(2:DoF-1) = diagonal(2:DoF-1) + epsilon(2:DoF-1)./h(2:DoF-1);
  diagonal(1)       = epsilon(1)/h(1);  %*\label{assemDiffusion-5}
  diagonal(DoF)     = epsilon(DoF-1)/h(DoF-1);  %*\label{assemDiffusion-6}

  x = [index1 index2 index3]; y = [index2 index1 index3];
  value = [diagonal2 diagonal2 diagonal];
  D=sparse(x,y,value);
