function [ D, nodes ] = assemDiffusion1Dkub( P, epsilon)

P=P(:);

NoE = length(P)-1;
h=P(2:length(P)) - P(1:length(P)-1);
DoF = 3*NoE+1;
nodes = zeros(DoF,1);

nodes(1:3:DoF) = P;

index = 0:NoE-1;%*\label{assemDiffusion1Dkub-1}
nodes(3*index+2) = nodes(3*index+1) + h(index+1)/3;  
nodes(3*index+3) = nodes(3*index+1) + h(index+1)*2/3;%*\label{assemDiffusion1Dkub-2}

T(:,1) = 3*index+1; T(:,2) = 3*index+2;
T(:,3) = 3*index+3; T(:,4) = 3*index+4;

s = length(epsilon); 
if s == 1
  epsilon = epsilon*ones(NoE,1);
elseif s == length(nodes)
  epsilon =(epsilon(2:s) + epsilon(1:s-1))./2;
end
if length(epsilon) ~= NoE
  msg = 'Dimension of nodes and epsilon do not agree.';
  error(msg)
end

DL = [37/10  -189/40  27/20  -13/40; -189/40 54/5  -297/40  27/20; 
      27/20  -297/40  54/5  -189/40; -13/40  27/20  -189/40  37/10];
D = sparse(DoF,DoF);
gamma = (1./h);
for x=1:4 %*\label{assemDiffusion1Dkub-3}
  for y=1:4
    temp = gamma*DL(x,y);
    temp = epsilon.*temp;
    tempMatrix = sparse(T(:,x), T(:,y),temp,DoF,DoF);
    D = D + tempMatrix;
  end
end %*\label{assemDiffusion1Dkub-4}