function [ R ] = assemReaction1D( nodes, r )

  nodes = nodes(:)'; DoF = length(nodes);
  h = nodes(2:length(nodes)) - nodes(1:length(nodes)-1);
  s = length(r); 
  if s == 1
    r = r*ones(size(h));
  elseif s == length(nodes)
    r =(r(2:s) + r(1:s-1))./2;
  end

  if length(r) ~= length(h)
    msg = 'Dimension of nodes and r do not agree.';
    error(msg)
  end

  index1 = 2:DoF;   index2 = 1:DoF-1;   index3 = 1:DoF;

  diagonal2 = r.*h; 

  diagonal(2:DoF-1) = (r(1:DoF-2).*h(1:DoF-2) + r(2:DoF-1).*h(2:DoF-1))*2;
  diagonal(1)       = 2*r(1)*h(1);
  diagonal(DoF)     = 2*r(DoF-1)*h(DoF-1);

  x = [index1 index2 index3]; y = [index2 index1 index3];
  value = [diagonal2 diagonal2 diagonal];
  value = value/6;
  R=sparse(x,y,value);

