function [ R ] = assemReaction1Dkub( P, r)
P=P(:);

NoE = length(P)-1;
h=P(2:length(P)) - P(1:length(P)-1);
DoF = 3*NoE+1;
nodes = zeros(DoF,1);

nodes(1:3:DoF) = P;

index = 0:NoE-1;
nodes(3*index+2) = nodes(3*index+1) + h(index+1)/3;  
nodes(3*index+3) = nodes(3*index+1) + h(index+1)*2/3;

T(:,1) = 3*index+1; T(:,2) = 3*index+2;
T(:,3) = 3*index+3; T(:,4) = 3*index+4;

s = length(r); 
if s == 1
  r = r*ones(NoE,1);
elseif s == length(nodes)
  r =(r(2:s) + r(1:s-1))./2;
end
if length(r) ~= NoE
  msg = 'Dimension of nodes and r do not agree.';
  error(msg)
end

RL = [8/105   33/560   -3/140   19/1680 ; 33/560  27/70    -27/560  -3/140 ;
     -3/140  -27/560   27/70    33/560  ; 19/1680 -3/140   33/560    8/105 ];

R = sparse(DoF,DoF);
gamma = h;
for x=1:4
  for y=1:4
    temp = gamma*RL(x,y);
    temp = r.*temp;
    tempMatrix = sparse(T(:,x), T(:,y),temp,DoF,DoF);
    R = R + tempMatrix;
  end
end