function [ A, b ] = assembPDE( eps, k, r, f, mesh)

A = assembDiffusion (eps, mesh.T, mesh.P);%*\label{assembPDE-1}
if ~isempty(k)
  A = A + assembConvection (k, mesh);
end
if ~isempty(r)
  A = A + assembReaction (r, mesh.T, mesh.P);
end
b = assembRightSide(mesh, f);%*\label{assembPDE-2}

if ~isempty(k)%*\label{assembPDE-7}
  kNorm     = max(sqrt(k(1,:).^2 + k(2,:).^2));%*\label{assembPDE-3}
  epsMin = min(eps);
  if (kNorm / epsMin) > 1%*\label{assembPDE-4}
    if  length(k) == mesh.NuDoF
      temp1 = (k(1,mesh.T(:,1)) + k(1,mesh.T(:,2)) + k(1,mesh.T(:,3)))./3;
      temp2 = (k(2,mesh.T(:,1)) + k(2,mesh.T(:,2)) + k(2,mesh.T(:,3)))./3;
      clear 'k';
      k(1,:) = temp1;
      k(2,:) = temp2;
    end
    
    deltaT = computeSDCoefficient(eps, k, mesh);
    b = b + assembRightSideStreamlineDiffusion(mesh, f, k, deltaT);%*\label{assembPDE-5}
    A  = A + assembStreamlineDiffusion (k, mesh, deltaT);%*\label{assembPDE-6}
    if ~isempty(r)
      A  = A + ( assembConvection ([deltaT .* r; deltaT .* r] .* k, mesh) )';
    end
  end%*\label{assembPDE-8}
end