P = [0 1 1 0 0.5; 0 0 1 1 0.5]; L = [3 4; 4 1; 1 2; 2 3];
T = [1 2 5; 1 4 5; 2 3 5; 3 4 5];
GL = zeros(4,1); GT = zeros(4,1);
[ mesh ] = buildMesh( T,P,[],GT,L,GL );
% for i=1:6
%  torefine = ones(mesh.NuTri,1);
%  [ mesh] = refineMesh( mesh, torefine );
% end
x = mesh.P(1,:)'; y = mesh.P(2,:)';

deltaT = 10^-2;
uAlt = zeros(size(x'));

for i=1:10
  [A, b] = assembPDE(deltaT, [], 1, uAlt, mesh);
  f = deltaT*ones(size(x')).*(1-exp(-5*i*deltaT));
  [ A, b ] = applyDirichletBoundaryConditions(A,b, mesh, 0,f);
  u = A\b;
  uAlt = u; 
end

figure(1);
trisurf(mesh.T,x,y,u);