m = load_gmsh2('Winkel.msh', [1 2]);
P(1,:) = m.POS(:,1); P(2,:) = m.POS(:,2);
T      = m.TRIANGLES(:,1:3); GT     = m.TRIANGLES(:,4);
L      = m.LINES(:,1:2); GL     = m.LINES(:,3);

[ mesh ] = buildMesh( T,P,[],GT,L,GL );
clear m T P GT L GL %*\label{script76-1}

epsIron = 22.530*10^-6;%*\label{script76-2}
epsT = epsIron*ones(length(mesh.T),1);%*\label{script76-4}
alpha = 5; kappa = 80.2; beta=alpha/kappa;%*\label{script76-3}

dt = 0.5; tEnd = 3600; %*\label{script76-5}
A = assembDiffusion (dt*epsIron, mesh.T, mesh.P);
A = A + applyRobinBoundaryConditions(mesh, 9, beta, dt*epsT );
R = assembReaction (1, mesh.T, mesh.P);
A = A + R; %*\label{script76-6}

TAir = 290; %*\label{script76-7}
T = TAir*ones(mesh.NuDoF,1);%*\label{script76-9}
bNeumann = applyNeumannBoundaryConditions(mesh, 9, TAir*beta,dt*epsT);%*\label{script76-8}

p=0.1; Tsafety = 15; u = 0;  %*\label{script76-11}
Toff = 420 - Tsafety; Ttarget  = 380;%*\label{script76-12}
protocol = [290,290,TAir,u];%*\label{script76-13}

for t=dt:dt:tEnd
  Tmax  = max(T); Tmean = mean(T); %*\label{script76-15}
  if mod(t,2) == 0%*\label{script76-16}
    eT = (Ttarget - Tmean);
    u = p*eT;
    if (Toff < Tmax) || (p*eT<-5)
      u = -5;
    elseif (p*eT>5)
      u = 5;
    end
    if TAir+u>900 %*\label{script76-19}
      TAir = 900; u = 0;
    elseif TAir+u<290
      TAir = 290; u = 0; 
    end %*\label{script76-20}
    TAir = TAir +  u;%*\label{script76-18}
    bNeumann = applyNeumannBoundaryConditions(mesh, 9, TAir*beta,dt*epsT); %*\label{script76-10}
  end %*\label{script76-17}
  b = assembRightSide(mesh, T); %*\label{script76-20a}
  b = b + bNeumann;%*\label{script76-21}
  T=A\b;%*\label{script76-22}
  protocol(end+1,:)= [Tmean,Tmax,TAir,u]';%*\label{script76-14}
end 

