function [ T ] = solveMyPDE( R, mesh, t, beta, dt, epsIron, Told, area )

epsT = epsIron*ones(length(mesh.T),1);
A = assembDiffusion (dt*epsIron, mesh.T, mesh.P);
A = A + applyRobinBoundaryConditions(mesh, 9, beta, dt*epsT );
A = A + R;

f = zeros(mesh.NuDoF,1);
if t >= 1.75 &&  t <= 2.3
  f(area) = 100;
end
b = assembRightSide(mesh, Told+dt*f);
bNeumann = applyNeumannBoundaryConditions(mesh, 9, 273.15*beta,dt*epsT);
b = b + bNeumann;
T=A\b;