% Physikalische Problemstellung
    r2 = [0.6 0.6 0.6]; r3 = [2.6 1.6 2.6]; q = 1.602176565*10^-19;
    eps = 8.85418781762*10^-12; factor = q^2 / (4*pi*eps);
    
    % Raum diskretisieren
    h = 0.4; [x,y,z] = meshgrid(0:h:4, 0:h:4, 0:h:4);
    
    % Abstaende zu den Punkten der Raumdiskretisierung berechnen
    d2x = x - r2(1);  d2y = y - r2(2);  d2z = z - r2(3);
    d3x = x - r3(1);  d3y = y - r3(2);  d3z = z - r3(3);
    
    % Feldberechnung ueber Matrixoperationen
    d2norm = sqrt(d2x.^2 + d2y.^2 + d2z.^2);
    d3norm = sqrt(d3x.^2 + d3y.^2 + d3z.^2);
    
    Fx = d2x ./ d2norm.^3 - d3x ./ d3norm.^3;
    Fy = d2y ./ d2norm.^3 - d3y ./ d3norm.^3;
    Fz = d2z ./ d2norm.^3 - d3z ./ d3norm.^3;
    
    % Abschlussskalierung
    Fx = factor*Fx; Fy = factor*Fy; Fz = factor*Fz;
    
    % Visualisierung
    eFieldplot = quiver3(x, y, z, Fx, Fy, Fz);
    axis([0 4 0 4 0 4]);
    xlabel('x'); ylabel('y'); zlabel('z');