m = load_gmsh2('karo.msh', [1 2]);
P(1,:) = m.POS(:,1); P(2,:) = m.POS(:,2);         
T      = m.TRIANGLES(:,1:3); GT     = m.TRIANGLES(:,4);    
L      = m.LINES(:,1:2); GL     = m.LINES(:,3);

mesh = buildMesh( T,P,[],GT,L,GL );
clear m T P GT L GL

A = assembDiffusion (3, mesh.T, mesh.P);
b = assembRightSide(mesh, 12);

% Gamma1
b = b + applyNeumannBoundaryConditions(mesh, 8, @(x,y)(-2*x-2*y)./sqrt(2) + 4*(1-x.^2-y.^2),3); %*\label{test53Robin1}
A = A + applyRobinBoundaryConditions(mesh, 8, 4, 3 ); %*\label{test53Robin4}
% Gamma2
b = b + applyNeumannBoundaryConditions(mesh, 7, @(x,y)(+2*x-2*y)./sqrt(2) + 4*(1-x.^2-y.^2),3); %*\label{test53Robin2}
A = A + applyRobinBoundaryConditions(mesh, 7, 4, 3 ); %*\label{test53Robin5}
% Gamma3
b = b + applyNeumannBoundaryConditions(mesh, 10, @(x,y)(+2*x+2*y)./sqrt(2)+ 4*(1-x.^2-y.^2),3); %*\label{test53Robin3}
A = A + applyRobinBoundaryConditions(mesh, 10, 4, 3 ); %*\label{test53Robin6}
% Gamma4
[ A, b ] = applyDirichletBoundaryConditions(A,b, mesh, 9, @(x,y)1-x.^2-y.^2);

u=A\b;
figure(1)
trisurf(mesh.T,mesh.P(1,:),mesh.P(2,:),u); 
figure(2)
lsg = 1-mesh.P(1,:).^2 - mesh.P(2,:).^2;
trisurf(mesh.T,mesh.P(1,:),mesh.P(2,:),abs(u-lsg')); 