m = load_gmsh2('karo.msh', [1 2]);
P(1,:) = m.POS(:,1); P(2,:) = m.POS(:,2);         
T      = m.TRIANGLES(:,1:3); GT     = m.TRIANGLES(:,4);    
L      = m.LINES(:,1:2); GL     = m.LINES(:,3);

[ mesh ] = buildMesh( T,P,[],GT,L,GL );
clear m T P GT L GL
u = 1 - mesh.P(1,:).^2 - mesh.P(2,:).^2;
[ gradu, s ]  = gradientPerElement( mesh, u );
E = sqrt(gradu(1,:).^2 + gradu(2,:).^2);

colormap gray
patch('Faces',mesh.T,'Vertices',mesh.P','FaceVertexCData',E','FaceColor','flat','FaceAlpha',0.3);
hold on;
quiver( s(1,:),s(2,:),gradu(1,:),gradu(2,:),0.7,'-k','LineWidth',0.6); %*\label{testScript61-1}
axis([-1 1 -1 1]);