m = load_gmsh2('unitSquareGrob.msh', [1 2]);
P(1,:) = m.POS(:,1); P(2,:) = m.POS(:,2);
T      = m.TRIANGLES(:,1:3); GT     = m.TRIANGLES(:,4);
L      = m.LINES(:,1:2); GL     = m.LINES(:,3);

[ mesh ] = buildMesh( T,P,[],GT,L,GL );
clear m T P GT L GL

subplot(2,2,1);
triplot(mesh.T,mesh.P(1,:),mesh.P(2,:),'k');
xlabel('x'); ylabel('y');
for i=1:20
  A = assembDiffusion (1, mesh.T, mesh.P);
  
  x = mesh.P(1,:); y = mesh.P(2,:);
  f = 3*10^5*(x.^4.*(12*10^3*x.^6-1) + y.^4.*(12*10^3*y.^6-1)).*exp(-10^4*(x.^6+y.^6));
  b = assembRightSide(mesh, -f);
  
  solution = exp(-10^4*(x.^6+y.^6));
  [ A, b ] = applyDirichletBoundaryConditions(A,b, mesh, 0,solution);
  
  u=A\b;
  
  if i<20
    [ gradDiff, torefine ]  = z2indicator( mesh, u, 0.5*10^-5, round(mesh.NuTri/25)); %*\label{testScript623-1}
    [ mesh] = refineMesh( mesh, torefine );
    
  end
end
subplot(2,2,2);
triplot(mesh.T,mesh.P(1,:),mesh.P(2,:),'k');
xlabel('x'); ylabel('y');
subplot(2,2,3);
trisurf(mesh.T,x,y,u,'EdgeColor','none');
view(135, 35);
colormap(summer);colorbar;
xlabel('x'); ylabel('y');zlabel('z');
subplot(2,2,4);
trisurf(mesh.T,x,y,abs(u-solution'),'EdgeColor','none');
view(30, 35);
colormap(summer);colorbar;
xlabel('x'); ylabel('y');zlabel('z');