m = load_gmsh2('unitSquare.msh', [1 2]);
P(1,:) = m.POS(:,1); P(2,:) = m.POS(:,2);
T      = m.TRIANGLES(:,1:3); GT     = m.TRIANGLES(:,4);
L      = m.LINES(:,1:2); GL     = m.LINES(:,3);

[ mesh ] = buildMesh( T,P,[],GT,L,GL );
clear m T P GT L GL
t(1)= 0; tEnd = 5; %*\label{testScript74-1}
dt = 1/4; counter=0;%*\label{testScript74-2}
u1 = zeros(mesh.NuDoF,1);
u2 = u1; u3 = u1; 
u3save=u1;
R = assembReaction (1, mesh.T, mesh.P);
L2Error(1)=0; maxError(1)=0; %*\label{testScript74-3}
while t(end)<tEnd
  counter = counter +1;

  if counter == 1 %*\label{testScript74-4}
    beta = [1 0 0]; alpha = 1;
    dt=dt/2;%*\label{testScript74-6}
  elseif counter == 2 
    beta = [4/3 -1/3 0]; alpha = 3/2;  
  elseif counter == 5
    beta = [18/11, -9/11, 2/11]; alpha = 11/6; 
    dt = dt*2; %*\label{testScript74-7}
  end %*\label{testScript74-5}

  if counter == 1 || counter == 2 || counter == 5 %*\label{testScript74-8}
    A = assembDiffusion (dt*2/alpha, mesh.T, mesh.P); %*\label{testScript74-10}
    A = A + R;
    A = applyDirichletBoundaryConditionsMatrix(A, mesh, 0);
  end%*\label{testScript74-9}
  t(end+1) = t(end) + dt; 
  temp = ( mesh.P(1,:).^2 + mesh.P(2,:).^2);
  uSol = exp(-10*temp)';%*\label{testScript74-11}
  f = ( 2*pi*cos(2*pi*t(end)) - 2*sin(2*pi*t(end))*( 400* (temp) - 40)).*uSol';
  bdfterm = beta(1)*u1' + beta(2)*u2' + beta(3)*u3';%*\label{testScript74-12}
  b = R*(dt/alpha*f + bdfterm)';%*\label{testScript74-13}
  b = applyDirichletBoundaryConditionsRightSide(b,mesh,0,uSol*sin(2*pi*t(end)));%*\label{testScript74-14}
  u=A\b;%*\label{testScript74-15}
  u3=u2; u2=u1; u1 = u; %*\label{testScript74-16}
  if counter == 2%*\label{testScript74-17}
    u2save = u;%*\label{testScript74-19}
  end
  if counter == 4
    u1 = u; u2 = u2save; u3 = u3save;%*\label{testScript74-20}
  end %*\label{testScript74-18}
  ue = u-uSol*sin(2*pi*t(end));
  maxError(end+1) = max(abs(ue));
  L2Error(end+1) = sqrt(ue'*R*ue);
end
plot(t,maxError,'*-');
hold on
plot(t,L2Error,'+--');
max(maxError)
max(L2Error)


