m = load_gmsh2('unitSquare.msh', [1 2]);
P(1,:) = m.POS(:,1); P(2,:) = m.POS(:,2);
T      = m.TRIANGLES(:,1:3); GT     = m.TRIANGLES(:,4);
L      = m.LINES(:,1:2); GL     = m.LINES(:,3);
[ mesh ] = buildMesh( T,P,[],GT,L,GL );
clear m T P GT L GL

epsIron = 22.530*10^-6;
alpha = 2; kappa = 80.2; beta=alpha/kappa;

dt = 0.02; dtMax = 1.5; dtMin = 0.001;
t=0; tEnd = 100;
relTol=10^-5; absTol=10^-10;
counter = 0; protocol = []; timeline=[];
p=1.1; rho=1;

T = 273.15*ones(mesh.NuDoF,1);
R = assembReaction (1, mesh.T, mesh.P);
area = mesh.P(1,:)<0.75 &  mesh.P(1,:)>0.5 & mesh.P(2,:)<0.75 &  mesh.P(2,:)>0.5;

while t < tEnd - 100*eps
  counter = counter+1;
  stopIteration = false;
  while ~stopIteration
    if t + dt>tEnd
      dt = tEnd - t;
    end
    Told   = T;
    Told   = solveMyPDE( R, mesh, t + dt/2, beta, dt/2, epsIron,Told,area);
    Tfine  = solveMyPDE( R, mesh, t + dt, beta, dt/2, epsIron,Told,area);
    
    Trude  = solveMyPDE( R, mesh, t + dt, beta, dt, epsIron,T,area);
    eta    = norm(Tfine-Trude);
    
    epsTol = max(relTol*norm(Tfine), absTol);
    dtNew  = min( [dtMax, rho*sqrt(epsTol/eta)*dt,p*dt] );
    dtNew  = min(max(dtNew,dtMin), tEnd - (t + dt));
    
    if (eta<epsTol) || ( (dtNew == dtMin) && (dNeu==dt) ) || (dtMin>tEnd - (t + dt))
      t = t +dt; T = Tfine;

      protocol(counter,1) = T(513); protocol(counter,2) = dt;
      timeline(counter)    = t;

      stopIteration = true;
    end
    dt = dtNew;
  end
end

TempAtCenter = interp1(timeline,protocol(:,1),[0:0.01:100],'linear');