P = [0 1 1 0 0.5; 0 0 1 1 0.5]; L = [3 4; 4 1; 1 2; 2 3];
T = [1 2 5; 1 4 5; 2 3 5; 3 4 5];
GL = zeros(4,1); GT = zeros(4,1);
[ mesh ] = buildMesh( T,P,[],GT,L,GL );
for i=1:4
  toRefine = ones(mesh.NuTri,1);
  [ mesh] = refineMesh( mesh, toRefine );
end
maxRefine = 8;
for i=1:maxRefine
  x = mesh.P(1,:); y = mesh.P(2,:);
  area = ( (x-0.2).^2+(y-0.5).^2<(0.1)^2 );
  f = 10*ones(size(x)).*area;
  eps = 10^-6; r = 1;
  k=[]; k(1,:) = ones(size(mesh.T(:,1))); k(2,:) = ones(size(mesh.T(:,1)));

  [ A, b ] = assembPDE( eps, k, r, f, mesh);
  [ A, b ] = applyDirichletBoundaryConditions(A,b, mesh, 0,zeros(size(x)));
  u=A\b;

  errorIndicator = u;
  errorIndicator(u>=0) = 0;
  R = assembReaction (r, mesh.T, mesh.P);
  errorIndicator = sqrt(errorIndicator'*R*errorIndicator);
  fprintf('Error: %e  DoF, %d \n',errorIndicator,mesh.NuDoF);
  if i<maxRefine
    [ ~, toRefine ]  = z2indicator( mesh, u, 10^-6, round(mesh.NuTri*0.1));
    [ mesh] = refineMesh( mesh, toRefine );
  end
end