m = load_gmsh2('kanal.msh', [1 2]); P=[];
P(1,:) = m.POS(:,1); P(2,:) = m.POS(:,2);
T      = m.TRIANGLES(:,1:3); GT     = m.TRIANGLES(:,4);
L      = m.LINES(:,1:2); GL     = m.LINES(:,3);
[ mesh ] = buildMesh( T,P,[],GT,L,GL );
x = mesh.P(1,:); y = mesh.P(2,:);
k=[]; k(1,:) = zeros(size(x)); k(2,:)=k(1,:);
c = 25;
index =find(y>=1);
fadey = 2/(2*pi)*atan(c*(y-2))+(1-2/pi*atan(c*(y-1)))/2;
k(1,index)= fadey(index);
fadex = 2/pi*atan(c*(x+1))+(1-2/pi*atan(c*(x-1)))-2;
fadey = (1-2/pi*atan(5*(y-1)))/5;
index =find(y<2 & x<1 & x>-1);
k(2,index)= fadex(index).*fadey(index);

k(1,mesh.Boundary(mesh.GBoundary==10))=0;

eps = 1.7*10^-3; r = 0;

f=zeros(size(x));
bereich = (x-2.5).^2 + (y-1.1).^2 < (0.05)^2;
f(bereich) = 0.1;
bereich = (x-2.5).^2 + (y-1.5).^2 < (0.05)^2;
f(bereich) = 0.1;
bereich = (x-2.5).^2 + (y-1.7).^2 < (0.05)^2;
f(bereich) = 0.1;
bereich = (x+0.8).^2 + (y+0.8).^2 < (0.05)^2;
f(bereich) = 0.1;
bereich = (x-0.8).^2 + (y+0.8).^2 < (0.05)^2;
f(bereich) = 0.1;
bereich = x.^2 + (y+0.8).^2 < (0.05)^2;
f(bereich) = 0.1;

ualt = zeros(size(x))';
dt = 0.25;

[ A, ~ ] = assembPDE( dt*eps, dt*k, 1 + dt*r, zeros(size(x)), mesh);
for i=mesh.Boundary
  A(i,find(A(i,:))) = 0;
  A(i,i) = 1;
end
gamma1=zeros(size(mesh.Boundary(mesh.GBoundary==9)));

for j=1:80
  fTime = ualt' + dt*f;
  b = assembRightSide(mesh, fTime);
  b(mesh.Boundary) = zeros(size(mesh.Boundary));
  b(mesh.Boundary(mesh.GBoundary==9)) = gamma1;
  u=A\b;
  u(u<0)=0;
  ualt = u;

  qBereich =  x>=-3+0.099 & x<=-3+0.101;
  qSchnitt=[y(qBereich);u(qBereich)']';
  qSchnitt = sortrows(qSchnitt);
  gamma1 = interp1(qSchnitt(:,1),qSchnitt(:,2),y(mesh.Boundary(mesh.GBoundary==9)));

  figure(1)
  trisurf(mesh.T,x,y,u,'EdgeColor','none','LineStyle','none')
  view(2); 
  titleStr = sprintf('%.02f Sekunden',dt*j);
  title(titleStr);axis('equal');
  set(gca, 'Clim', [0 0.03])
  colorbar; colormap(gray);xlabel('x');ylabel('y');
  drawnow

  
    figure(2)
  plot(qSchnitt(:,1),qSchnitt(:,2),'k','LineWidth',1.5);xlabel('y');ylabel('u');
  drawnow
end