m = load_gmsh2('unitSquare.msh', [1 2]);
P(1,:) = m.POS(:,1);         P(2,:) = m.POS(:,2);
T      = m.TRIANGLES(:,1:3); GT     = m.TRIANGLES(:,4);
L      = m.LINES(:,1:2);     GL     = m.LINES(:,3);

[ mesh ] = buildMesh( T,P,[],GT,L,GL );
clear m T P GT L GL

x = mesh.P(1,:); y = mesh.P(2,:);
uSol = (1-x.^2-y.^2)';
f = 4 + uSol.^2;
i=1; maxItr = 50; %*\label{testScript91-12}
uDiff=1; diffTol=10^-6; %*\label{testScript91-13}
ualt = zeros(size(x))'; %*\label{testScript91-14}

while (uDiff(end)>diffTol) || i>maxItr
  [ A, b ] = assembPDE( 1, [], ualt, f, mesh);
  [ A, b ] = applyDirichletBoundaryConditions(A,b, mesh, 0,uSol);
  u = A\b;
  uDiff(end+1) = norm(ualt-u);
  ualt = u;
  i=i+1;
end
norm(uSol-u) %*\label{testScript91-24}
semilogy(uDiff(2:end),'k*-');
xlabel('Iterationen');ylabel('||ualt - u||_2');