P = [0 30 30 0 15; 0 0 30 30 15]; L = [3 4; 4 1; 1 2; 2 3];
T = [1 2 5; 1 4 5; 2 3 5; 3 4 5];
GL = zeros(4,1); GT = zeros(4,1);
[ mesh ] = buildMesh( T,P,[],GT,L,GL );
for i=1:6
 torefine = ones(mesh.NuTri,1);
 [ mesh] = refineMesh( mesh, torefine );
end
x = mesh.P(1,:)'; y = mesh.P(2,:)';

index = find(x<2 & x>1 & y<6 & y>5);
uStart = zeros(size(x));
uStart(index) = 50; 
f = zeros(size(x));
s = 0.5*(tanh(0.1*(x-15).^2 + 0.0025*(y-15).^2) + tanh(0.0025*(x-15).^2 + 0.1*(y-15).^2));
r = (2.6238*s + 1.0267)*10^-3;
vareps = 10^-3;
K = 199*s + 1; 

tiere=[];
deltaT = 6;
j=1; maxItr = 50; 
diffPic=1; diffTol=10^-6;
vareps  = deltaT*vareps;
uOld    = uStart; 
uOldPic = uOld;
simEnde = 24*7*39/deltaT;

for i=1:simEnde
  while (diffPic>diffTol) || j>maxItr
    j=j+1;
    reaction = 1 - deltaT*r + (r*deltaT./K).*uOldPic;
    [ A, b ] = assembPDE( vareps, [], reaction, uOld, mesh);
    [ A, b ] = applyDirichletBoundaryConditions(A,b, mesh, 0,f);
    u = A\b;
    diffPic = norm(uOldPic-u);
    uOldPic = u;
  end
  u(u<0) = 0; 
  tiere(i)=sum(u)/length(u)*900;
  uOld = u; uOldPic = uOld;
  diffPic=1; j = 0;
  figure(1)
  trisurf(mesh.T,x,y,u,'EdgeColor','none','LineStyle','none');
  zlim([0, 200]); colormap(1-gray);
  title([num2str(i*deltaT),' h']);
  colorbar; drawnow;
end
figure(2)
plot([6:6:24*7*39], tiere)